// ------------------------------------------------------------------------------------
// irr::core::array<triangle3df> wrappers
// NOTES:
// did not wrap the const version of getLast()
// ------------------------------------------------------------------------------------

extern "C" array<triangle3df>* IrrCore_Array_triangle3df_new()
{
	return new array<triangle3df>();
}

extern "C" array<triangle3df>* IrrCore_Array_triangle3df_newWithSize(u32 start_count)
{
	return new array<triangle3df>(start_count);
}

extern "C" array<triangle3df>* IrrCore_Array_triangle3df_newFromOther(array<triangle3df>* other)
{
	return new array<triangle3df>(*other);
}

extern "C" void IrrCore_Array_triangle3df_del(array<triangle3df>* arr)
{
	if (arr)
		delete arr;
		
	arr=0;
}

extern "C" u32 IrrCore_Array_triangle3df_allocated_size(array<triangle3df>* arr)
{
	if (arr)
		return arr->allocated_size();
	else
		return 0;
}

extern "C" void IrrCore_Array_triangle3df_clear(array<triangle3df>* arr)
{
	if (arr)
		arr->clear();
}

extern "C" const triangle3df* IrrCore_Array_triangle3df_const_pointer(array<triangle3df>* arr)
{
	if (arr)
		arr->const_pointer();
}

extern "C" triangle3df* IrrCore_Array_triangle3df_pointer(array<triangle3df>* arr)
{
	if (arr)
		arr->pointer();
}

extern "C" bool IrrCore_Array_triangle3df_empty(array<triangle3df>* arr)
{
	if (arr)
		return arr->empty();
	else
		return true;
}

extern "C" void IrrCore_Array_triangle3df_eraseWithCount(array<triangle3df>* arr,u32 idx,s32 count)
{
	if (arr)
		arr->erase(idx,count);
}

extern "C" void IrrCore_Array_triangle3df_erase(array<triangle3df>* arr,u32 idx)
{
	if (arr)
		arr->erase(idx);
}

// do not delete this pointer
extern "C" triangle3df* IrrCore_Array_triangle3df_getLast(array<triangle3df>* arr)
{
	if (arr)
		return &arr->getLast();
	else
		return 0;
}

// do not delete this pointer
extern "C" triangle3df* IrrCore_Array_triangle3df_elementAt(array<triangle3df>* arr,u32 idx)
{
	if (arr)
		return &(*arr)[idx];
	else
		return 0;
}

extern "C" void IrrCore_Array_triangle3df_insert(array<triangle3df>* arr,triangle3df* element,u32 idx=0)
{
	if (arr)
		arr->insert(*element,idx);
}

extern "C" void IrrCore_Array_triangle3df_Eq(array<triangle3df>* arr,array<triangle3df>* other)
{
	if (arr)
		*arr=*other;
}

extern "C" void IrrCore_Array_triangle3df_push_back(array<triangle3df>* arr,triangle3df* element)
{
	if (arr)
		arr->push_back(*element);
}

extern "C" void IrrCore_Array_triangle3df_push_front(array<triangle3df>* arr,triangle3df* element)
{
	if (arr)
		arr->push_front(*element);
}

extern "C" void IrrCore_Array_triangle3df_reallocate(array<triangle3df>* arr,u32 new_size)
{
	if (arr)
		arr->reallocate(new_size);
}

extern "C" void IrrCore_Array_triangle3df_set_free_when_destroyed(array<triangle3df>* arr,bool f)
{
	if (arr)
		arr->set_free_when_destroyed(f);
}

extern "C" void IrrCore_Array_triangle3df_set_pointer(array<triangle3df>* arr,triangle3df newPointer[],u32 size)
{
	if (arr)
		arr->set_pointer(newPointer,size);
}

extern "C" void IrrCore_Array_triangle3df_set_sorted(array<triangle3df>* arr,bool bVal)
{
	if (arr)
		arr->set_sorted(bVal);
}

extern "C" void IrrCore_Array_triangle3df_set_used(array<triangle3df>* arr,bool bVal)
{
	if (arr)
		arr->set_used(bVal);
}

extern "C" u32 IrrCore_Array_triangle3df_size(array<triangle3df>* arr)
{
	if (arr)
		return arr->size();
	else
		return 0;
}

/*
extern "C" s32 IrrCore_Array_triangle3df_linear_reverse_search(array<triangle3df>* arr,triangle3df* find)
{
	if (arr)
		return arr->linear_reverse_search(*find);
	else
		return -1;
}

extern "C" s32 IrrCore_Array_triangle3df_linear_search(array<triangle3df>* arr,triangle3df* find)
{
	if (arr)
		return arr->linear_search(*find);
	else
		return -1;
}

extern "C" s32 IrrCore_Array_triangle3df_binary_search(array<triangle3df>* arr,triangle3df* find)
{
	if (arr)
		return arr->binary_search(*find);
	else
		return -1;
}



extern "C" s32 IrrCore_Array_triangle3df_binary_searchWithBounds(array<triangle3df>* arr,triangle3df* find,s32 left,s32 right)
{
	if (arr)
		return arr->binary_search(*find,left,right);
	else
		return -1;
}

extern "C" void IrrCore_Array_triangle3df_sort(array<triangle3df>* arr)
{
	if (arr)
		arr->sort();
}
*/


